//------------------------------------------------------------------
#property  copyright "mladen"
#property  link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  30
#property indicator_level2  70

//
//
//
//
//

extern int    OsmaFast         = 12;
extern int    OsmaSlow         = 26;
extern int    OsmaPrice        = PRICE_CLOSE;
extern int    OsmaMode         = MODE_LWMA;
extern int    OsmaSignalPeriod = 9;
extern int    OsmaSignalMode   = MODE_LWMA;
extern int    RsiPeriod        = 14;

double value[];
double valueda[];
double valuedb[];
double macd[];
double slope[];
double osma[];
double sign[];

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,value);
   SetIndexBuffer(1,valueda);
   SetIndexBuffer(2,valuedb);
   SetIndexBuffer(3,macd);
   SetIndexBuffer(4,sign);
   SetIndexBuffer(5,osma);
   SetIndexBuffer(6,slope);
return(0);
}
int deinit() { return(0); }

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,valueda,valuedb);
   for(i=limit; i>=0; i--) macd[i] = iMA(NULL,0,OsmaFast,0,OsmaMode,OsmaPrice,i)-iMA(NULL,0,OsmaSlow,0,OsmaMode,OsmaPrice,i);
   for(i=limit; i>=0; i--) sign[i] = iMAOnArray(macd,0,OsmaSignalPeriod,0,OsmaSignalMode,i);
   for(i=limit; i>=0; i--) osma[i] = macd[i]-sign[i];
   for(i=limit; i>=0; i--)
   {
      value[i]   = iRSIOnArray(osma,0,RsiPeriod,i);
      valueda[i] = EMPTY_VALUE;
      valuedb[i] = EMPTY_VALUE;
      slope[i]   = slope[i+1];      
         if (value[i]>value[i+1]) slope[i] =  1;
         if (value[i]<value[i+1]) slope[i] = -1;
         if (slope[i]==-1) PlotPoint(i,valueda,valuedb,value);
   }         
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}